﻿using System;
using UnityEngine;

namespace FX
{
	// Token: 0x0200074C RID: 1868
	public class FX_ScaleCurve_incremental : MonoBehaviour
	{
		// Token: 0x06003004 RID: 12292 RVA: 0x001019EC File Offset: 0x001019EC
		private void Update()
		{
			float x = this.keyValueMagnification * this.CurveX.Evaluate(this.duration);
			float y = this.keyValueMagnification * this.CurveY.Evaluate(this.duration);
			float z = this.keyValueMagnification * this.CurveZ.Evaluate(this.duration);
			this.animState = new Vector3(x, y, z);
			base.transform.localScale += this.animState - this.preState;
			this.preState = this.animState;
			this.duration += Time.deltaTime / this.keyTimeMagnification;
		}

		// Token: 0x040055B2 RID: 21938
		[SerializeField]
		private float keyValueMagnification = 1f;

		// Token: 0x040055B3 RID: 21939
		[SerializeField]
		private float keyTimeMagnification = 1f;

		// Token: 0x040055B4 RID: 21940
		private float duration;

		// Token: 0x040055B5 RID: 21941
		private Vector3 preState = new Vector3(1f, 1f, 1f);

		// Token: 0x040055B6 RID: 21942
		private Vector3 animState;

		// Token: 0x040055B7 RID: 21943
		public AnimationCurve CurveX = new AnimationCurve(new Keyframe[]
		{
			new Keyframe(0f, 0f, 3f, 3f),
			new Keyframe(1f, 1f)
		});

		// Token: 0x040055B8 RID: 21944
		public AnimationCurve CurveY = new AnimationCurve(new Keyframe[]
		{
			new Keyframe(0f, 0f, 3f, 3f),
			new Keyframe(1f, 1f)
		});

		// Token: 0x040055B9 RID: 21945
		public AnimationCurve CurveZ = new AnimationCurve(new Keyframe[]
		{
			new Keyframe(0f, 0f, 3f, 3f),
			new Keyframe(1f, 1f)
		});
	}
}
