﻿using System;
using UnityEngine;
using UnityEngine.UI;

namespace FX
{
	// Token: 0x02000763 RID: 1891
	[ExecuteInEditMode]
	[RequireComponent(typeof(Image))]
	public class FX_UI_CMN_BG_V115_TitleLogo : MonoBehaviour
	{
		// Token: 0x06003042 RID: 12354 RVA: 0x00102AC8 File Offset: 0x00102AC8
		private void Start()
		{
			if (null == this.material_)
			{
				this.material_ = new Material(this._shader);
				this.material_.hideFlags = (HideFlags.HideInHierarchy | HideFlags.DontSaveInEditor | HideFlags.NotEditable | HideFlags.DontSaveInBuild);
			}
			this.reset();
		}

		// Token: 0x06003043 RID: 12355 RVA: 0x00102B00 File Offset: 0x00102B00
		private void OnDidApplyAnimationProperties()
		{
			this.reset();
		}

		// Token: 0x06003044 RID: 12356 RVA: 0x00102B08 File Offset: 0x00102B08
		private void OnDestroy()
		{
			if (null != this.material_)
			{
				UnityEngine.Object.DestroyImmediate(this.material_);
				this.material_ = null;
			}
		}

		// Token: 0x06003045 RID: 12357 RVA: 0x00102B30 File Offset: 0x00102B30
		private void reset()
		{
			Image component = base.transform.GetComponent<Image>();
			if (component == null)
			{
				return;
			}
			this.initPropertyId();
			component.material = this.material_;
			component.material.SetColor(this.id_TintColor, this.TintColor_);
			component.material.SetFloat(this.id_Exposure, this.Exposure_);
			component.material.SetFloat(this.id_Opacity, this.Opacity_);
			component.material.SetFloat(this.id_OverExposure_MulToOpacity, (float)(this.OverExposure_MulToOpacity_ ? 1 : 0));
			component.material.SetFloat(this.id_OverExposure_ClampEmission, (float)(this.OverExposure_ClampEmission_ ? 1 : 0));
			component.material.SetTexture(this.id_Tex2, this.Tex2_);
			component.material.SetFloat(this.id_Cutoff, this.Cutoff_);
			component.material.SetFloat(this.id_Border_Rotate, this.Border_Rotate_);
			component.material.SetFloat(this.id_Scrool_Time, this.Scrool_Time_);
			component.material.SetFloat(this.id_Specular_Offset, this.Specular_Offset_);
			component.material.SetFloat(this.id_Holo, this.Holo_);
			component.material.SetTexture(this.id_Mask, this.Mask_);
			component.material.SetFloat(this.id_Steps, this.Steps_);
			component.material.SetTexture(this.id_Steps_Tex, this.Steps_Tex_);
			component.material.SetFloat(this.id_Step_Blend, this.Step_Blend_);
			component.material.SetFloat(this.id_SystemTime, this.SystemTime_);
		}

		// Token: 0x06003046 RID: 12358 RVA: 0x00102CF4 File Offset: 0x00102CF4
		private void initPropertyId()
		{
			if (this.id_Opacity != 0)
			{
				return;
			}
			this.id_TintColor = Shader.PropertyToID("_TintColor");
			this.id_Exposure = Shader.PropertyToID("_Exposure");
			this.id_Opacity = Shader.PropertyToID("_Opacity");
			this.id_OverExposure_MulToOpacity = Shader.PropertyToID("_OverExposure_MulToOpacity");
			this.id_OverExposure_ClampEmission = Shader.PropertyToID("_OverExposure_ClampEmission");
			this.id_Tex2 = Shader.PropertyToID("_Tex2");
			this.id_Cutoff = Shader.PropertyToID("_Cutoff");
			this.id_Border_Rotate = Shader.PropertyToID("_Border_Rotate");
			this.id_Scrool_Time = Shader.PropertyToID("_Scrool_Time");
			this.id_Specular_Offset = Shader.PropertyToID("_Specular_Offset");
			this.id_Holo = Shader.PropertyToID("_Holo");
			this.id_Mask = Shader.PropertyToID("_Mask");
			this.id_Steps = Shader.PropertyToID("_Steps");
			this.id_Steps_Tex = Shader.PropertyToID("_Steps_Tex");
			this.id_Step_Blend = Shader.PropertyToID("_Step_Blend");
			this.id_SystemTime = Shader.PropertyToID("_SystemTime");
		}

		// Token: 0x04005625 RID: 22053
		[SerializeField]
		private Shader _shader;

		// Token: 0x04005626 RID: 22054
		[SerializeField]
		private Color TintColor_ = Color.white;

		// Token: 0x04005627 RID: 22055
		[Range(-20f, 20f)]
		[SerializeField]
		private float Exposure_;

		// Token: 0x04005628 RID: 22056
		[SerializeField]
		private float Opacity_ = 1f;

		// Token: 0x04005629 RID: 22057
		[SerializeField]
		private bool OverExposure_MulToOpacity_ = true;

		// Token: 0x0400562A RID: 22058
		[SerializeField]
		private bool OverExposure_ClampEmission_ = true;

		// Token: 0x0400562B RID: 22059
		[SerializeField]
		private Texture2D Tex2_;

		// Token: 0x0400562C RID: 22060
		[SerializeField]
		private float Cutoff_ = 0.5f;

		// Token: 0x0400562D RID: 22061
		[SerializeField]
		private float Border_Rotate_;

		// Token: 0x0400562E RID: 22062
		[Range(-1f, 1f)]
		[SerializeField]
		private float Scrool_Time_ = 1f;

		// Token: 0x0400562F RID: 22063
		[Range(0f, 5f)]
		[SerializeField]
		private float Specular_Offset_ = 2.5f;

		// Token: 0x04005630 RID: 22064
		[Range(0f, 1f)]
		[SerializeField]
		private float Holo_ = 1.5f;

		// Token: 0x04005631 RID: 22065
		[SerializeField]
		private Texture2D Mask_;

		// Token: 0x04005632 RID: 22066
		[Range(0f, 5f)]
		[SerializeField]
		private float Steps_ = 4f;

		// Token: 0x04005633 RID: 22067
		[SerializeField]
		private Texture2D Steps_Tex_;

		// Token: 0x04005634 RID: 22068
		[Range(0f, 1f)]
		[SerializeField]
		private float Step_Blend_ = 1f;

		// Token: 0x04005635 RID: 22069
		[SerializeField]
		private float SystemTime_ = 1f;

		// Token: 0x04005636 RID: 22070
		private Material material_;

		// Token: 0x04005637 RID: 22071
		private int id_TintColor;

		// Token: 0x04005638 RID: 22072
		private int id_Exposure;

		// Token: 0x04005639 RID: 22073
		private int id_Opacity;

		// Token: 0x0400563A RID: 22074
		private int id_OverExposure_MulToOpacity;

		// Token: 0x0400563B RID: 22075
		private int id_OverExposure_ClampEmission;

		// Token: 0x0400563C RID: 22076
		private int id_Tex2;

		// Token: 0x0400563D RID: 22077
		private int id_Cutoff;

		// Token: 0x0400563E RID: 22078
		private int id_Border_Rotate;

		// Token: 0x0400563F RID: 22079
		private int id_Scrool_Time;

		// Token: 0x04005640 RID: 22080
		private int id_Specular_Offset;

		// Token: 0x04005641 RID: 22081
		private int id_Holo;

		// Token: 0x04005642 RID: 22082
		private int id_Mask;

		// Token: 0x04005643 RID: 22083
		private int id_Steps;

		// Token: 0x04005644 RID: 22084
		private int id_Steps_Tex;

		// Token: 0x04005645 RID: 22085
		private int id_Step_Blend;

		// Token: 0x04005646 RID: 22086
		private int id_SystemTime;

		// Token: 0x04005647 RID: 22087
		private const HideFlags HideAndDontSave = HideFlags.HideInHierarchy | HideFlags.DontSaveInEditor | HideFlags.NotEditable | HideFlags.DontSaveInBuild;
	}
}
