﻿using System;
using UnityEngine;
using UnityEngine.UI;

namespace FX
{
	// Token: 0x02000765 RID: 1893
	[RequireComponent(typeof(Image))]
	[ExecuteInEditMode]
	public class FX_Unlit_Rate_2Tex_PolarCoordinate : MonoBehaviour
	{
		// Token: 0x0600304E RID: 12366 RVA: 0x0010348C File Offset: 0x0010348C
		private void Start()
		{
			if (null == this.material_)
			{
				this.material_ = new Material(this._shader);
				this.material_.hideFlags = (HideFlags.HideInHierarchy | HideFlags.DontSaveInEditor | HideFlags.NotEditable | HideFlags.DontSaveInBuild);
			}
			this.reset();
		}

		// Token: 0x0600304F RID: 12367 RVA: 0x001034C4 File Offset: 0x001034C4
		private void OnDidApplyAnimationProperties()
		{
			this.reset();
		}

		// Token: 0x06003050 RID: 12368 RVA: 0x001034CC File Offset: 0x001034CC
		private void OnDestroy()
		{
			if (null != this.material_)
			{
				UnityEngine.Object.DestroyImmediate(this.material_);
				this.material_ = null;
			}
		}

		// Token: 0x06003051 RID: 12369 RVA: 0x001034F4 File Offset: 0x001034F4
		private void reset()
		{
			Image component = base.transform.GetComponent<Image>();
			if (component == null)
			{
				return;
			}
			this.initPropertyId();
			component.material = this.material_;
			component.material.SetColor(this.id_TintColor, this.TintColor_);
			component.material.SetFloat(this.id_Exposure, this.Exposure_);
			component.material.SetFloat(this.id_Opacity, this.Opacity_);
			component.material.SetFloat(this.id_OverExposure_MulToOpacity, (float)(this.OverExposure_MulToOpacity_ ? 1 : 0));
			component.material.SetFloat(this.id_OverExposure_ClampEmission, (float)(this.OverExposure_ClampEmission_ ? 1 : 0));
			component.material.SetTexture(this.id_Tex2, this.Tex2_);
			component.material.SetFloat(this.id_Switch_uv, (float)(this.Switch_uv_ ? 1 : 0));
			component.material.SetFloat(this.id_Exp_Radial_easing, this.Exp_Radial_easing_);
			component.material.SetFloat(this.id_Use_CircleMask, (float)(this.Use_CircleMask_ ? 1 : 0));
			component.material.SetFloat(this.id_Exp_CircleMask, this.Exp_CircleMask_);
			component.material.SetFloat(this.id_Cutoff, this.Cutoff_);
			component.material.SetFloat(this.id_Border_Rotate, this.Border_Rotate_);
			component.material.SetFloat(this.id_Border_Amount, this.Border_Amount_);
			component.material.SetFloat(this.id_Border_Thickness, this.Border_Thickness_);
		}

		// Token: 0x06003052 RID: 12370 RVA: 0x001036A4 File Offset: 0x001036A4
		private void initPropertyId()
		{
			if (this.id_Opacity != 0)
			{
				return;
			}
			this.id_TintColor = Shader.PropertyToID("_TintColor");
			this.id_Exposure = Shader.PropertyToID("_Exposure");
			this.id_Opacity = Shader.PropertyToID("_Opacity");
			this.id_OverExposure_MulToOpacity = Shader.PropertyToID("_OverExposure_MulToOpacity");
			this.id_OverExposure_ClampEmission = Shader.PropertyToID("_OverExposure_ClampEmission");
			this.id_Tex2 = Shader.PropertyToID("_Tex2");
			this.id_Switch_uv = Shader.PropertyToID("_Switch_uv");
			this.id_Exp_Radial_easing = Shader.PropertyToID("_Exp_Radial_easing");
			this.id_Use_CircleMask = Shader.PropertyToID("_Use_CircleMask");
			this.id_Exp_CircleMask = Shader.PropertyToID("_Exp_CircleMask");
			this.id_Cutoff = Shader.PropertyToID("_Cutoff");
			this.id_Border_Rotate = Shader.PropertyToID("_Border_Rotate");
			this.id_Border_Amount = Shader.PropertyToID("_Border_Amount");
			this.id_Border_Thickness = Shader.PropertyToID("_Border_Thickness");
		}

		// Token: 0x04005679 RID: 22137
		[SerializeField]
		private Shader _shader;

		// Token: 0x0400567A RID: 22138
		[SerializeField]
		private Color TintColor_ = Color.white;

		// Token: 0x0400567B RID: 22139
		[Range(-20f, 20f)]
		[SerializeField]
		private float Exposure_;

		// Token: 0x0400567C RID: 22140
		[SerializeField]
		private float Opacity_ = 1f;

		// Token: 0x0400567D RID: 22141
		[SerializeField]
		private bool OverExposure_MulToOpacity_ = true;

		// Token: 0x0400567E RID: 22142
		[SerializeField]
		private bool OverExposure_ClampEmission_ = true;

		// Token: 0x0400567F RID: 22143
		[SerializeField]
		private Texture2D Tex2_;

		// Token: 0x04005680 RID: 22144
		[SerializeField]
		private bool Switch_uv_;

		// Token: 0x04005681 RID: 22145
		[Range(-5f, 5f)]
		[SerializeField]
		private float Exp_Radial_easing_;

		// Token: 0x04005682 RID: 22146
		[SerializeField]
		private bool Use_CircleMask_;

		// Token: 0x04005683 RID: 22147
		[SerializeField]
		[Range(-5f, 5f)]
		private float Exp_CircleMask_ = -5f;

		// Token: 0x04005684 RID: 22148
		private float Cutoff_ = 0.5f;

		// Token: 0x04005685 RID: 22149
		[SerializeField]
		private float Border_Rotate_;

		// Token: 0x04005686 RID: 22150
		[Range(0.0001f, 1f)]
		[SerializeField]
		private float Border_Amount_ = 0.05f;

		// Token: 0x04005687 RID: 22151
		[SerializeField]
		[Range(0f, 1f)]
		private float Border_Thickness_ = 1f;

		// Token: 0x04005688 RID: 22152
		private Material material_;

		// Token: 0x04005689 RID: 22153
		private int id_TintColor;

		// Token: 0x0400568A RID: 22154
		private int id_Exposure;

		// Token: 0x0400568B RID: 22155
		private int id_Opacity;

		// Token: 0x0400568C RID: 22156
		private int id_OverExposure_MulToOpacity;

		// Token: 0x0400568D RID: 22157
		private int id_OverExposure_ClampEmission;

		// Token: 0x0400568E RID: 22158
		private int id_Tex2;

		// Token: 0x0400568F RID: 22159
		private int id_Switch_uv;

		// Token: 0x04005690 RID: 22160
		private int id_Exp_Radial_easing;

		// Token: 0x04005691 RID: 22161
		private int id_Use_CircleMask;

		// Token: 0x04005692 RID: 22162
		private int id_Exp_CircleMask;

		// Token: 0x04005693 RID: 22163
		private int id_Cutoff;

		// Token: 0x04005694 RID: 22164
		private int id_Border_Rotate;

		// Token: 0x04005695 RID: 22165
		private int id_Border_Amount;

		// Token: 0x04005696 RID: 22166
		private int id_Border_Thickness;

		// Token: 0x04005697 RID: 22167
		private const HideFlags HideAndDontSave = HideFlags.HideInHierarchy | HideFlags.DontSaveInEditor | HideFlags.NotEditable | HideFlags.DontSaveInBuild;
	}
}
