﻿using System;
using UnityEngine;

namespace MU3
{
	// Token: 0x02000737 RID: 1847
	public class MotionEffectShuriken : MotionEffectBase
	{
		// Token: 0x06002FA4 RID: 12196 RVA: 0x000FE440 File Offset: 0x000FE440
		public void initialize(GameObject gameObject)
		{
			this._gameObject = gameObject;
			this._particleSystem = gameObject.GetComponentInChildren<ParticleSystem>();
			this._isGameObjectValid = (this._gameObject != null);
		}

		// Token: 0x06002FA5 RID: 12197 RVA: 0x000FE468 File Offset: 0x000FE468
		public override void destroy()
		{
			if (this._gameObject != null)
			{
				UnityEngine.Object.Destroy(this._gameObject);
			}
		}

		// Token: 0x06002FA6 RID: 12198 RVA: 0x000FE488 File Offset: 0x000FE488
		public override void start()
		{
			if (this._particleSystem != null)
			{
				this._particleSystem.Play();
			}
		}

		// Token: 0x06002FA7 RID: 12199 RVA: 0x000FE4A8 File Offset: 0x000FE4A8
		public override void stop()
		{
			if (this._particleSystem != null)
			{
				this._particleSystem.Stop();
			}
		}

		// Token: 0x06002FA8 RID: 12200 RVA: 0x000FE4C8 File Offset: 0x000FE4C8
		public override bool isFinished()
		{
			return !(this._particleSystem != null) || this._particleSystem.IsAlive();
		}

		// Token: 0x06002FA9 RID: 12201 RVA: 0x000FE4E8 File Offset: 0x000FE4E8
		public override void setPosition(Vector3 position)
		{
			if (!this._isGameObjectValid)
			{
				return;
			}
			if (this._gameObject == null)
			{
				this._isGameObjectValid = false;
				return;
			}
			this._gameObject.transform.position = position;
		}

		// Token: 0x06002FAA RID: 12202 RVA: 0x000FE520 File Offset: 0x000FE520
		public override void setRotation(Quaternion rotation)
		{
			if (!this._isGameObjectValid)
			{
				return;
			}
			if (this._gameObject == null)
			{
				this._isGameObjectValid = false;
				return;
			}
			this._gameObject.transform.rotation = rotation;
		}

		// Token: 0x04005532 RID: 21810
		private GameObject _gameObject;

		// Token: 0x04005533 RID: 21811
		private ParticleSystem _particleSystem;

		// Token: 0x04005534 RID: 21812
		private bool _isGameObjectValid;
	}
}
